<?php
defined('is_running') or die('Not an entry point...');

define('ckDefault', "toolbar : \n[\n['Bold', 'Italic', 'Underline', '-', 'Undo', 'Redo', '-', 'NumberedList', 'BulletedList', '-', 'JustifyLeft', 'JustifyCenter', 'JustifyRight', '-',\n'Format', '-', 'Link', '-', 'About']\n],\ntoolbarLocation : 'bottom',\ntoolbarStartupExpanded:'true',\nuiColor : '#9AB8F3',\nheight:'12em'\n");

class Edit
{
	public $title;
	public $pagelabel;
	public $filename;
	public $keypublic;
	public $keyprivate;

	function __construct()
	{
		global $gptitles,$addonPathCode,$dataDir,$config;
		$this->title = 'smtpcontact';
		$this->template = $addonPathCode.'/template.php';
		$this->formname = $dataDir.'/data/_pages/'.$this->title.'.php';
		$this->formlabel = isset($gptitles[$this->title]) ? $gptitles[$this->title]['label'] : 'SMTP Contact Form';
		$this->keypublic = common::ConfigValue('recaptcha_public','');
		$this->keyprivate = common::ConfigValue('recaptcha_private','');
		if (file_exists($addonPathCode.'/cfg.php'))
		{
			$this->data = explode('?'.'>',file_get_contents($addonPathCode.'/cfg.php'),2);
			$this->data = unserialize($this->data[1]);
		}
		else
		{
			$this->data = array(
					"name" => array( "show"=>true, "req"=>true, "valid"=>true )
					,"phone" => array( "show"=>true, "req"=>false, "valid"=>true )
					,"email" => array( "show"=>true, "req"=>true, "valid"=>true )
					,"subject" => array( "show"=>true, "req"=>true, "valid"=>true )
					,"message" => array( "show"=>true, "req"=>false, "valid"=>false, "ta_params"=>'cols="50" rows="5" style="height:20em; width:98%; border:1px solid #ccc;"' )
					,"Addition" => array( "show"=>true )
					,"Captcha" => array( "show"=>false, "rctheme" => "red" )
					,"level" => 0
					,"WordWrap" => 50
					,"IsHTML" => true
					,"EnableCKE" => true
					,"ckValues" => ckDefault
					,"SMTPAuth" => false
					,"SMTPSecure" => ""
					,"Host" => ""
					,"Port" => 25
					,"Username" => ""
					,"Password" => ""
					,"Language" => "en"
					,"CharSet" => "utf-8"
					,"msg_noscript" => "<p><b>You must enable JavaScript to use this form.</b></p> <p>The web really does look a lot nicer with JavaScript enabled &#9786;</p> <p>Just block the sites that overly use and abuse JavaScript &#9786;</p> "
					,"msg_listing" => "<i>Your data that will be posted by email:</i>"
					,"msg_success" => "<b>Thank You!</b><br/>Your message was successfully sent!&#9786;<br/>We'll get back to you as soon as possible."
					,"msg_fail" => "<b>Sorry</b><br/>We encountered an error sending your message &#9785;"
					,"msg_rcerror" => "The reCAPTCHA wasn't entered correctly. Go back and try it again. (reCAPTCHA said: [ERRORCODE])"
					,"msg_presubject" => "Message from my website: " );
		}
	}
	
	function getfile($filename,$part)
	{
		if (!file_exists($filename))
			return '';
		$string = file_get_contents($filename);
		$content = explode('?'.'>',$string,2);
		if ($part==0) return $content[0];
		if ($part==1) return $content[1];
		if ($part==2) return $content;//array
	}
	
	function menu()
	{
		global $config, $gptitles, $addonRelativeCode,$page;
		$page->head .= '<script type="text/javascript" src="'.$addonRelativeCode.'/collapsible.js"></script>';
		echo '<div style="font-size:16px; margin-bottom:1.5em;">SMTP Contact Form Creation</div>'.PHP_EOL;
		
		echo '<div onclick="openClose(\'a1\')" class="link"> <span id="tick_a1">+</span> <span>1. Settings</span> </div>';
		echo '<div id="a1" class="links" style="display:none">';
		
		echo '<form action="'.common::GetUrl('Admin_SMTP_contact_form').'" method="post">'.PHP_EOL;
		
		echo '<div style="clear:both;height:1em;"></div>';
		echo '<span>A) Template setup</span><br/>';
		echo '<table cellspacing="1" cellpadding="1" style="width:99%;border:1px solid black">';
		echo '<colgroup><col style="width:15%"/><col style="width:15%"/><col style="width:15%"/><col style="width:15%"/><col style="width:40%"/></colgroup>';
		echo '<thead><tr><td>item</td><td>have it on form</td><td>is required</td><td>other validations</td><td>notes</td></tr></thead>';
		echo '<tbody>';
		echo '<tr>';
		echo '<td style="color:blue">name</td>';
		echo '<td> <input name="name_show" type="checkbox" '.($this->data['name']['show']?'checked="checked"' : '').'/></td>'.PHP_EOL;
		echo '<td> <input name="name_req" type="checkbox" '.($this->data['name']['req']?'checked="checked"' : '').'/></td>'.PHP_EOL;
		echo '<td> <input name="name_valid" type="checkbox" '.($this->data['name']['valid']?'checked="checked"' : '').'/> minlength=2 maxlength=50 </td>'.PHP_EOL;
		echo '<td>-</td>'.PHP_EOL;
		echo '</tr>';
		echo '<tr>';
		echo '<td style="color:blue">phone</td>';
		echo '<td> <input name="phone_show" type="checkbox" '.($this->data['phone']['show']?'checked="checked"' : '').'/></td>'.PHP_EOL;
		echo '<td> <input name="phone_req" type="checkbox" '.($this->data['phone']['req']?'checked="checked"' : '').'/></td>'.PHP_EOL;
		echo '<td> <input name="phone_valid" type="checkbox" '.($this->data['phone']['valid']?'checked="checked"' : '').'/> maxlen=30 </td>'.PHP_EOL;
		echo '<td>-</td>'.PHP_EOL;
		echo '</tr>';
		echo '<tr>';
		echo '<td style="color:blue">email</td>';
		echo '<td> <input name="email_show" type="checkbox" '.($this->data['email']['show']?'checked="checked"' : '').'/></td>'.PHP_EOL;
		echo '<td> <input name="email_req" type="checkbox" '.($this->data['email']['req']?'checked="checked"' : '').'/></td>'.PHP_EOL;
		echo '<td> <input name="email_valid" type="checkbox" '.($this->data['email']['valid']?'checked="checked"' : '').'/> valid email </td>'.PHP_EOL;
		echo '<td>-</td>'.PHP_EOL;
		echo '</tr>';
		echo '<tr>';
		echo '<td style="color:blue">subject</td>';
		echo '<td> <input name="subject_show" type="checkbox" '.($this->data['subject']['show']?'checked="checked"' : '').'/></td>'.PHP_EOL;
		echo '<td> <input name="subject_req" type="checkbox" '.($this->data['subject']['req']?'checked="checked"' : '').'/></td>'.PHP_EOL;
		echo '<td> <input name="subject_valid" type="checkbox" '.($this->data['subject']['valid']?'checked="checked"' : '').'/> minlen=2 maxlen=50 </td>'.PHP_EOL;
		echo '<td>-</td>'.PHP_EOL;
		echo '</tr>';
		echo '<tr>';
		echo '<td style="color:blue">message</td>';
		echo '<td> <input name="message_show" type="checkbox" '.($this->data['message']['show']?'checked="checked"' : '').'/></td>'.PHP_EOL;
		echo '<td> <input name="message_req" type="checkbox" '.($this->data['message']['req']?'checked="checked"' : '').'/></td>'.PHP_EOL;
		echo '<td> <input name="message_valid" type="checkbox" '.($this->data['message']['valid']?'checked="checked"' : '').'/> minlen=10 maxlen=1000 </td>'.PHP_EOL;
		echo '<td'.( ($this->data['EnableCKE']&&($this->data['message']['req']||$this->data['message']['valid'])) ? ' style="color:red;"' : '' ).'> Message validation doesn\'t work correctly, when ckEditor is enabled. It forces users to click twice for send button. In this case it is recommended either to turn off all validations for message or disable CKEditor. </td>'.PHP_EOL;
		echo '</tr>';
		echo '<tr>';
		echo '<td style="color:blue">Additive antispam protection</td>';
		echo '<td> <input name="addition_show" type="checkbox" '.($this->data['Addition']['show']?'checked="checked"' : '').'/></td>'.PHP_EOL;
		echo '<td> - </td>'.PHP_EOL;
		echo '<td> - </td>'.PHP_EOL;
		echo '<td>The [NUMBERS] string must be present within the contact form for this protection to work</td>'.PHP_EOL;
		echo '</tr>';
		echo '<tr>';
		echo '<td style="color:blue">Captcha antispam protection</td>';
		echo '<td> <input name="captcha_show" type="checkbox" '.($this->data['Captcha']['show']?'checked="checked"' : '').'/></td>'.PHP_EOL;
		echo '<td>-</td>'.PHP_EOL;
		echo '<td>-</td>'.PHP_EOL;
		echo '<td>The [CAPTCHA] string must be present within the contact form, because it sends the deciphered antispam texts to your server - how does it work is described in <a href="http://code.google.com/intl/en/apis/recaptcha/intro.html" target="_blank">google docs</a></td>'.PHP_EOL;
		echo '</tr>';
		echo '</tbody>';
		echo '</table>';
		echo '<div style="clear:both;height:1em;"></div>';
		
		echo '<span>B) Email settings</span><br/>';
		echo '<span style="color:green">Emails will be delivered to:</span> <input name="Receiver" type="text" value="'.( isset($config["toemail"]) ? str_replace('"','&quot;',$config["toemail"]) : '' ).'" size="25" /> = <input name="ReceiverName" type="text" value="'.( isset($config["toname"]) ? str_replace('"','&quot;',$config["toname"]) : '' ).'" size="25" /> <br/>'.PHP_EOL;
		echo 'Is HTML? (default is yes, uncheck it to send plain text) <input name="IsHTML" type="checkbox" '.($this->data['IsHTML']?'checked="checked"' : '').'/><br/>'.PHP_EOL;
		echo 'Wordwrap (default 50 characters): <input name="WordWrap" type="text" value="'.$this->data['WordWrap'].'" /><br/>'.PHP_EOL;
		echo 'Character Set (email encoding): <input name="CharSet" type="text" value="'.$this->data['CharSet'].'" /><br/>'.PHP_EOL;
		echo 'Use SMTP Authentization? (default is not.) <input name="SMTPAuth" type="checkbox" '.($this->data['SMTPAuth']?'checked="checked"' : '').' /><br/>'.PHP_EOL;
		echo 'SMTPAuth Host (Mail Server): <input name="Host" type="text" value="'.$this->data['Host'].'" /> '.PHP_EOL;
		echo '+ Port: <input name="Port" type="text" value="'.$this->data['Port'].'" /><br/>'.PHP_EOL;
		echo 'SMTPAuth Secure (Options are "", "ssl" or "tls"): <input name="SMTPSecure" type="text" value="'.$this->data['SMTPSecure'].'" /><br/> '.PHP_EOL;
		echo 'SMTPAuth Username: <input name="Username" type="text" value="'.$this->data['Username'].'" /><br/>'.PHP_EOL;
		echo 'SMTPAuth Password: <input name="Password" type="password" value="'.$this->data['Password'].'" /><br/>'.PHP_EOL;
		echo '<div style="clear:both;height:1em;"></div>';
		
		echo '<span>C) Messages and Form Label</span><br/>';
		echo '<span style="color:green">Contact form label:</span>';
		echo '<input name="pagelabel" type="text" value="'.$this->formlabel.'" /><br/>'.PHP_EOL;
		echo 'Noscript message:';
		echo '<input name="msg_noscript" type="text" value="'.str_replace('"','&quot;', $this->data['msg_noscript']).'" style="width:99%" /><br/>'.PHP_EOL;
		echo 'Message to write before listing (leave empty to disable)';
		echo '<input name="msg_listing" type="text" value="'.str_replace('"','&quot;', $this->data['msg_listing']).'" style="width:99%" /><br/>'.PHP_EOL;
		echo 'Message for incorrect reCAPTCHA:';
		echo '<input name="msg_rcerror" type="text" value="'.str_replace('"','&quot;', $this->data['msg_rcerror']).'" style="width:99%" /><br/>'.PHP_EOL;
		echo 'Message on successful send';
		echo '<input name="msg_success" type="text" value="'.str_replace('"','&quot;', $this->data['msg_success']).'" style="width:99%" /><br/>'.PHP_EOL;
		echo 'Message on failed send';
		echo '<input name="msg_fail" type="text" value="'.str_replace('"','&quot;', $this->data['msg_fail']).'" style="width:99%" /><br/>'.PHP_EOL;
		echo 'Text to be written before the Subject:';
		echo '<input name="msg_presubject" type="text" value="'.str_replace('"','&quot;', $this->data['msg_presubject']).'" style="width:99%" /><br/>'.PHP_EOL;
		echo 'PHPMailer language : <select name="Language">';
		echo '<optgroup label="PHPMailer language">';
		echo '<option value="ar"'. ($this->data['Language']=='ar' ? 'selected="selected"':'') .'> ar - Arabic </option>';
		echo '<option value="br"'. ($this->data['Language']=='br' ? 'selected="selected"':'') .'> br - Portuguese </option>';
		echo '<option value="ca"'. ($this->data['Language']=='ca' ? 'selected="selected"':'') .'> ca - Catalan </option>';
		echo '<option value="cz"'. ($this->data['Language']=='cz' ? 'selected="selected"':'') .'> cz - Czech </option>';
		echo '<option value="de"'. ($this->data['Language']=='de' ? 'selected="selected"':'') .'> de - German </option>';
		echo '<option value="dk"'. ($this->data['Language']=='dk' ? 'selected="selected"':'') .'> dk - Danish </option>';
		echo '<option value="en"'. ($this->data['Language']=='en' ? 'selected="selected"':'') .'> en - English </option>';
		echo '<option value="es"'. ($this->data['Language']=='es' ? 'selected="selected"':'') .'> es - Spanish </option>';
		echo '<option value="et"'. ($this->data['Language']=='et' ? 'selected="selected"':'') .'> et - Estonian </option>';
		echo '<option value="fi"'. ($this->data['Language']=='fi' ? 'selected="selected"':'') .'> fi - Finnish </option>';
		echo '<option value="fo"'. ($this->data['Language']=='fo' ? 'selected="selected"':'') .'> fo - Faroese </option>';
		echo '<option value="fr"'. ($this->data['Language']=='fr' ? 'selected="selected"':'') .'> fr - French </option>';
		echo '<option value="hu"'. ($this->data['Language']=='hu' ? 'selected="selected"':'') .'> hu - Hungarian </option>';
		echo '<option value="ch"'. ($this->data['Language']=='ch' ? 'selected="selected"':'') .'> ch - Chinese </option>';
		echo '<option value="it"'. ($this->data['Language']=='it' ? 'selected="selected"':'') .'> it - Italian </option>';
		echo '<option value="ja"'. ($this->data['Language']=='ja' ? 'selected="selected"':'') .'> ja - Japanese </option>';
		echo '<option value="nl"'. ($this->data['Language']=='nl' ? 'selected="selected"':'') .'> nl - Dutch </option>';
		echo '<option value="no"'. ($this->data['Language']=='no' ? 'selected="selected"':'') .'> no - Norwegian </option>';
		echo '<option value="pl"'. ($this->data['Language']=='pl' ? 'selected="selected"':'') .'> pl - Polish </option>';
		echo '<option value="ro"'. ($this->data['Language']=='ro' ? 'selected="selected"':'') .'> ro - Romanian </option>';
		echo '<option value="ru"'. ($this->data['Language']=='ru' ? 'selected="selected"':'') .'> ru - Russian </option>';
		echo '<option value="se"'. ($this->data['Language']=='se' ? 'selected="selected"':'') .'> se - Swedish </option>';
		echo '<option value="sk"'. ($this->data['Language']=='sk' ? 'selected="selected"':'') .'> sk - Slovak </option>';
		echo '<option value="tr"'. ($this->data['Language']=='tr' ? 'selected="selected"':'') .'> tr - Turkish </option>';
		echo '<option value="zh"'. ($this->data['Language']=='zh' ? 'selected="selected"':'') .'> zh - Traditional Chinese </option>';
		echo '<option value="zh_cn"'. ($this->data['Language']=='zh_cn' ? 'selected="selected"':'') .'> zh_cn - Simplified Chinese </option>';
		echo '</optgroup>';
		echo '</select>';
		echo '<div style="clear:both;height:1em;"></div>';
		
		echo '<span>D) CKEditor</span><br/>';
		echo '<textarea id="ckValues" name="ckValues" rows="11" cols="35" wrap="off" style="vertical-align: top; float:right">'.$this->data['ckValues'].'</textarea>';
		echo 'Enable CKEditor? <input name="EnableCKE" type="checkbox" '.($this->data['EnableCKE']?'checked="checked"' : '').'/> '.PHP_EOL;
		echo '- when checked, these settings will be used &#9658;<br/>';
		echo 'You can customize it with the following menu items:'.PHP_EOL;
		echo "Source , Save , NewPage , Preview , Templates ,
		     Cut , Copy , Paste , PasteText , PasteFromWord , Print ,  SpellChecker ,  Scayt ,
		     Undo , Redo , Find , Replace , SelectAll , RemoveFormat , Form ,  Checkbox ,  Radio ,  
		     TextField ,  Textarea ,  Select ,  Button ,  ImageButton ,  HiddenField , BidiLtr ,  BidiRtl ,
		     Bold , Italic , Underline , Strike , Subscript , Superscript , NumberedList , BulletedList , 
		     Outdent , Indent , Blockquote , CreateDiv , JustifyLeft , JustifyCenter , JustifyRight , JustifyBlock , 
		     Link , Unlink , Anchor , Image , Flash , Table , HorizontalRule , Smiley , SpecialChar , PageBreak ,
		     Styles , Format , Font , FontSize , TextColor , BGColor , Maximize ,  ShowBlocks and About.<br/>";
		echo '('.common::Link('Admin_SMTP_contact_form','set defaults','cmd=set_defaults','title="Set default values for CKEditor"').' / <a href="http://docs.cksource.com/ckeditor_api/symbols/CKEDITOR.config.html" title="CKEditor 3 JavaScript API Documentation" target="_blank">ck info</a> )<br/>';
		echo '<div style="clear:both;height:1em;"></div>';
		
		echo '<span>E) Other settings</span><br/>';
		echo 'reCaptcha Theme : <select name="captcha_rctheme">';
		echo '<optgroup label="reCaptcha theme">';
		echo '<option value="red"'. ($this->data['Captcha']['rctheme']=='red' ? 'selected="selected"':'') .'> red </option>';
		echo '<option value="white"'. ($this->data['Captcha']['rctheme']=='white' ? 'selected="selected"':'') .'> white </option>';
		echo '<option value="blackglass"'. ($this->data['Captcha']['rctheme']=='blackglass' ? 'selected="selected"':'') .'> blackglass </option>';
		echo '<option value="clean"'. ($this->data['Captcha']['rctheme']=='clean' ? 'selected="selected"':'') .'> clean </option>';
		echo '</optgroup>';
		echo '</select><br/>';
		echo '<span style="color:green">reCaptcha public key:</span> '.$this->keypublic.'<br/>';
		echo '<span style="color:green">reCaptcha private key:</span> '.$this->keyprivate.'<br/>';
		echo '<span style="color:green">reCaptcha language:</span> '.common::ConfigValue('recaptcha_language','').'<br/>';

		echo 'Message area parameters: <input name="message_params" type="text" value="'.str_replace('"','&quot;',$this->data['message']['ta_params']).'" /><br/>'.PHP_EOL;

		echo 'Both keys and language must be set in gpEasy\'s '.common::Link('Admin_Configuration','Admin Configuration').' menu to make Captcha run.<br/>'.PHP_EOL;
		echo '<div style="clear:both;height:1em;"></div>';
		
		echo '<span style="color:green">The settings in green don\'t need create new form. They are read in runtime from gpEasy\'s configuration.</span> All other settings are hardcoded in the form, so it must be recreated for them to take effect.<br/>';
		echo '<div style="clear:both;height:1em;"></div>';
		echo '<input type="submit" name="save_settings" value="Save settings" /> &nbsp;&nbsp;&nbsp;&nbsp;'.PHP_EOL;
		echo '<input type="reset" value="Reset settings" /> &nbsp;&nbsp;&nbsp;&nbsp;'.PHP_EOL;
		echo common::Link('Admin_SMTP_contact_form','Delete config file','cmd=del_config','title="This link deletes cfg.php file"').' &nbsp;&nbsp;&nbsp;&nbsp;'.PHP_EOL;
		echo '<a href="http://trueacu.com/gpEasy_Contact_Forms" target="_blank">Plugin documentation</a><br/>';
		echo '</form><br/><br/>';
		
		echo '</div>';//end of div id="a1"
		
		echo common::Link('Admin_SMTP_contact_form','2. Create new template','cmd=create_template','title="Create new contact form template"').'<br/>';
		echo common::Link('Admin_SMTP_contact_form','3. Edit template','cmd=edit_template','title="Edit contact form template"').'<br/>';
		echo common::Link('Admin_SMTP_contact_form','4. View template','cmd=view_template','title="View contact form template"').'<br/>';
		echo common::Link('Admin_SMTP_contact_form','5. Create new smtp contact form','cmd=create_form','title="Create new smtp contact form using your template and settings"').'<br/>';
		echo common::Link('Admin_SMTP_contact_form','6. Publish/hide contact page','cmd=publish','title="Publish or hide your contact form page"').'<br/><br/>';
		echo '<hr/>';
	}
	
	function edit_template()
	{
		global $page,$addonPathCode;
		$page->head .= '<script type="text/javascript" src="'. common::GetDir('/include/thirdparty/ckeditor_34/ckeditor.js') .'"></script>';
		echo '<div style="font-size:16px; margin-bottom:1.5em;">Edit template</div>'.PHP_EOL;
		if ($this->data['Addition']['show'] || $this->data['Captcha']['show'])
		{
			echo 'Please note: place the text ';
			if ($this->data['Addition']['show'])
				echo '[NUMBERS] ';
			if ($this->data['Captcha']['show'])
				echo 'and "[CAPTCHA]" ';
			echo 'on some appropriate place, if you want this protection enabled.<br/>'.PHP_EOL;
		}
		echo '<form action="'.common::GetUrl('Admin_SMTP_contact_form').'" method="post">';
		echo '<textarea name="textfield" rows="20" cols="50" style="width:100%">'.htmlspecialchars($this->getfile($this->template,1)).'</textarea>'.PHP_EOL;
		echo '<input type="submit" name="save_data" value="Save template" /> <br/>'.PHP_EOL;
		echo '</form>';
		echo '<script type="text/javascript"> CKEDITOR.replace( \'textfield\' ); </script>';
	}
	
	function create_form()
	{
		global $gptitles,$addonPathCode,$addonRelativeCode,$config,$dataDir;
		if (!file_exists($this->template))
		{
			echo 'Template not exists.';
			return;
		}
		
		if ($this->keypublic=='' || $this->keyprivate=='')
		{
			$this->data['Captcha']['show']=false;
			echo 'reCaptcha can not be used, because the keys are not set.<br/>';
		}
		if (!isset($gptitles[$this->title]))//if page is not registered yet, add it
		{
			$gptitles[$this->title]['type'] = 'page';
			$gptitles[$this->title]['label'] = $this->formlabel;

			admin_tools::SavePagesPHP();//saves page's description
		}
		
		// ############################### template ###########################
		$t = $this->getfile($this->template,1); //get second splitted part
		$x = explode('[NUMBERS]',$t,2);
		if (($this->data['Addition']['show']==true) && (count($x)>1)) //if enabled and [NUMBERS] string was found
		{
			$t = $x[0].'<'.'?'.'php echo $n1.\' + \'.$n2; '.'?'.'>'.$x[1];
			$disableadditionchecking=false;
		}
		else
		{
			$t = $x[0].(isset($x[1])?$x[1]:'');
			$disableadditionchecking=true;
		}
		
		$x = explode('[CAPTCHA]',$t,2);
		if (count($x)>1) //if [CAPTCHA] string was found
		{
			if ($this->data['Captcha']==true) //if captcha is enabled
			{
				$t = $x[0].'<'.'?'.'php '.PHP_EOL;
				$t .= ' requi'.'re_once(\''.$dataDir.'/include/thirdparty/recaptchalib.php\');
						$publickey = common::ConfigValue(\'recaptcha_public\',\'\');
						echo recaptcha_get_html($publickey);'.PHP_EOL;
				$t .= '?'.'>'.$x[1].PHP_EOL;
			}
			else
			{
				$t = $x[0].(isset($x[1])?$x[1]:''); // this removes the [CAPTCHA] string from template
			}
		}
		if ($this->data['EnableCKE'])
		{
			$t .= ' <script type="text/javascript">
				CKEDITOR.replace( \'sender_message\',
				{
					'.$this->data['ckValues'].'
				});
				</script> '.PHP_EOL;
		}
		
		// ############################### begin ###########################
		
		$begin = '<script src="'.$addonRelativeCode.'/form_validator.js" type="text/javascript"></script>'.PHP_EOL;
		$begin .= '<script type="text/javascript"> var RecaptchaOptions = { lang : \'<?p'.'hp echo common::ConfigValue(\'recaptcha_language\',\'\'); ?'.'>\', theme : \''.$this->data['Captcha']['rctheme'].'\' }; </script>'.PHP_EOL;
		$begin .= '<'.'?'.'php global $page; $page->head=\'<link href="'.$addonRelativeCode.'/scf_style.css" media="screen" rel="stylesheet" type="text/css" />\'; ?'.'>'.PHP_EOL;
		
		$begin .= '<div class="simplecontactform">'.PHP_EOL;
		$begin .= '<noscript>'.($this->data['msg_noscript']).'</noscript>'.PHP_EOL;
		
		$begin .= '<'.'?'.'php global $config;'.PHP_EOL;
		
		if ($this->data['Captcha']['show']==true)
		{
			$begin .= 'if (isset($_POST["submitForm"])) {'.PHP_EOL;
			$begin .= 'requi'.'re_once(\''.$dataDir.'/include/thirdparty/recaptchalib.php\');'.PHP_EOL;
			$begin .= '$privatekey = common::ConfigValue(\'recaptcha_private\',\'\');'.PHP_EOL;
			$begin .= '$resp = recaptcha_check_answer($privatekey, $_SERVER["REMOTE_ADDR"], $_POST["recaptcha_challenge_field"], $_POST["recaptcha_response_field"]);'.PHP_EOL;
			$z = explode('[ERRORCODE]',$this->data['msg_rcerror'],2);
			$begin .= 'if (!$resp->is_valid) {
				echo "'.$z[0].'".$resp->error."'.(isset($z[1])?$z[1]:'').'"; } }'.PHP_EOL.PHP_EOL;
			$begin .= 'if(isset($_POST["submitForm"]) && $_POST["url"]==\'\' && $resp->is_valid){'.PHP_EOL;
		}
		else
		{
			$begin .= 'if(isset($_POST["submitForm"]) && $_POST["url"]==\'\'){'.PHP_EOL;
		}
		
		$begin .= 'requi'.'re_once("'.$addonPathCode.'/class.phpmailer.php"); '.PHP_EOL;
		$begin .= '$mail = new PHPMailer();'.PHP_EOL;
		$begin .= '$mail->SetLanguage("'.$this->data['Language'].'");'.PHP_EOL;
		$begin .= '$mail->IsHTML('.($this->data['IsHTML']?'true':'false').');'.PHP_EOL;
		$begin .= '$mail->WordWrap = '.$this->data['WordWrap'].';'.PHP_EOL;
		$begin .= '$mail->CharSet = "'.$this->data['CharSet'].'";'.PHP_EOL;
		$begin .= '$msg_presubject=\''.str_replace('\'','\\\'', $this->data['msg_presubject']).'\';'.PHP_EOL;
		$begin .= '$mail->SMTPAuth='.($this->data['SMTPAuth']?'true':'false').';'.PHP_EOL;
		if ($this->data['SMTPAuth']=='true')
		{
			$begin .= '$mail->SMTPSecure="'.$this->data['SMTPSecure'].'";'.PHP_EOL;
			$begin .= '$mail->Host="'.($this->data['Host']).'";'.PHP_EOL;
			$begin .= '$mail->Port="'.($this->data['Port']).'";'.PHP_EOL;
			$begin .= '$mail->Username="'.($this->data['Username']).'";'.PHP_EOL;
			$begin .= '$mail->Password="'.($this->data['Password']).'";'.PHP_EOL;
		}
		if ($this->data['msg_listing']!='')
		{
			$begin .= 'echo \''.str_replace('\'','\\\'', $this->data['msg_listing']).'<br/>\';'.PHP_EOL;
			$begin .= 'foreach ($_POST as $param => $value)'.PHP_EOL;
			$begin .= '{ if ($param!=\'website\') echo $param.\': \'.($param==\'url\'?\'antispam is correct\':$value).\'<br/>\'; }'.PHP_EOL;
			$begin .= 'echo \'<br/>\';'.PHP_EOL;
		}
		$y=str_replace('\'','\\\'', $this->data['msg_success']);
		$begin .= '$msg_success=\''.$y.'\';'.PHP_EOL;
		$y=str_replace('\'','\\\'', $this->data['msg_fail']);
		$begin .= '$msg_fail=\''.$y.'\';'.PHP_EOL;
		//$begin .= $x[1];
		
		$begin .= '$mail->IsSMTP();'; // we use SMTP server to send e-mail
		$begin .= '$mail->SMTPDebug = false;'.PHP_EOL;
		$begin .= '	$eol = ($mail->ContentType=="text/plain") ? PHP_EOL.PHP_EOL : "<br/>";'.PHP_EOL;
		$begin .= '	$_name = $_POST["sender_name"];'.PHP_EOL;
		$begin .= '	$_email = $_POST["sender_email"];'.PHP_EOL;
		$begin .= '		$_subject = $_POST["sender_subject"];'.PHP_EOL;
		$begin .= '		$_message = $_POST["sender_message"];'.PHP_EOL;
		$begin .= '			$_phone = $_POST["sender_phone"];'.PHP_EOL;
		$begin .= '			$_body = "CONTACT FORM MESSAGE:".$eol;'.PHP_EOL;
		$begin .= '			$_body .= \'Name: \'.(isset($_name)? $_name:\'-\').$eol;'.PHP_EOL;
		$begin .= '			$_body .= \'Phone: \'.(isset($_phone)? $_phone:\'-\').$eol;'.PHP_EOL;
		$begin .= '			$_body .= \'Email: \'.(isset($_email)? $_email:\'-\').$eol;'.PHP_EOL;
		$begin .= '			$_body .= \'Subject: \'.(isset($_subject)? $_subject:\'-\').$eol;'.PHP_EOL;
		$begin .= '			$_body .= \'Message: \'.$_message;'.PHP_EOL;
		$begin .= '			$mail->AddAddress($config[\'toemail\'],$config[\'toname\']); // e-mail address of receiver'.PHP_EOL;
		$begin .= '			//$mail->AddAddress("another.mail@another.address.com");'.PHP_EOL; // e-mail address of another receiver,...
		$begin .= '			$mail->FromName = $_name; // Sender\'s full name'.PHP_EOL;
		$begin .= '			$mail->From = $_email; // sender\'s e-mail address'.PHP_EOL;
		$begin .= '			$mail->AddReplyTo($_email,$_name);'.PHP_EOL;
		$begin .= '			$mail->Return = $_email; // if email will not be delivered, notice will return here'.PHP_EOL;
		$begin .= '			$mail->Subject = $msg_presubject.$_subject;'.PHP_EOL;
		$begin .= '				$mail->Body .= $_body;'.PHP_EOL;
		$begin .= '		//set the headers'.PHP_EOL;
		$begin .= '			//$_header = "From: $_name < $_email >" . "\r\n" ."Reply-To: $_name < $_email >" . "\r\n";'.PHP_EOL;
		$begin .= '			//send the email(s)'.PHP_EOL;
		$begin .= '			//$sent = mail($_to, $_subject, $_body.$_message, $_header);'.PHP_EOL;
		$begin .= '			$sent = $mail->Send();//via smtp'.PHP_EOL;
		$begin .= '			if($sent)'.PHP_EOL;
		$begin .= '				{echo $msg_success;}'.PHP_EOL;
		$begin .= '			else'.PHP_EOL;
		$begin .= '				{echo $msg_fail;}'.PHP_EOL;
		$begin .= '			echo \'<br/><br/>\';'.PHP_EOL;
		$begin .= '	  }'.PHP_EOL;
		$begin .= '	if (isset($_POST["submitForm"]) && $_POST[\'url\']!=\'\')'.PHP_EOL;
		$begin .= '		{ echo \'Spam was detected. Message was not send.\';} '.PHP_EOL;
		$begin .= '	$n1 = rand()%10; $n2 = rand()%10; ?'.'>'.PHP_EOL;
		$begin .= '		<div id="scf_jsContentWrapper" style="display:none;">'.PHP_EOL;
		
		if ($this->data['EnableCKE'])
		{
			$begin .= '<script type="text/javascript" src="'. common::GetDir('/include/thirdparty/ckeditor_34/ckeditor.js') .'"></script>'.PHP_EOL;
		}
		
		// ############################### end ###########################
		
		$end = '';
		$end .= '</div>'.PHP_EOL; //end of "scf_jsContentWrapper" division
		$end .= '<script type="text/javascript">'.PHP_EOL;
		$end .= '	$(\'#scf_jsContentWrapper\').removeAttr(\'style\');'.PHP_EOL;
		$end .= '</script>'.PHP_EOL;
		$end .= '	<script type="text/javascript">'.PHP_EOL;
		$end .= '		var frmvalidator  = new Validator("scf_contact");'.PHP_EOL;
		$end .= '			frmvalidator.EnableOnPageErrorDisplaySingleBox();'.PHP_EOL;
		// Sender's Name
		if ($this->data['name']['show'] && $this->data['name']['req'])
		{
			$end .= '			frmvalidator.addValidation("sender_name","req","Please enter your name.");'.PHP_EOL;
		}
		if ($this->data['name']['show'] && $this->data['name']['valid'])
		{
			$end .= '			frmvalidator.addValidation("sender_name","minlength=2","Please enter your name - that\'s too short to be a real name.");'.PHP_EOL;
			$end .= '			frmvalidator.addValidation("sender_name","maxlength=50","Please enter your name - 50 characters max.");'.PHP_EOL;
		}
		// sender_phone
		if ($this->data['phone']['show'] && $this->data['phone']['req'])
		{
			$end .= '			frmvalidator.addValidation("sender_phone","req","Please enter your phone number.");'.PHP_EOL;
		}
		if ($this->data['phone']['show'] && $this->data['phone']['valid'])
		{
			$end .= '			frmvalidator.addValidation("sender_phone","maxlen=30","That\'s too long to be a phone number.");'.PHP_EOL;
		}
		// sender_email
		if ($this->data['email']['show'] && $this->data['email']['req'])
		{
			$end .= '			frmvalidator.addValidation("sender_email","req","Please enter your email address.");'.PHP_EOL;
		}
		if ($this->data['email']['show'] && $this->data['email']['valid'])
		{
			$end .= '			frmvalidator.addValidation("sender_email","email","Please enter your email address.");'.PHP_EOL;
		}
		// sender_subject
		if ($this->data['subject']['show'] && $this->data['subject']['req'])
		{
			$end .= '			frmvalidator.addValidation("sender_subject","req","Please enter a subject.");'.PHP_EOL;
		}
		if ($this->data['subject']['show'] && $this->data['subject']['valid'])
		{
			$end .= '			frmvalidator.addValidation("sender_subject","minlen=2","Please enter a subject - that\'s too short.");'.PHP_EOL;
			$end .= '			frmvalidator.addValidation("sender_subject","maxlen=50","Please enter a subject - 50 characters max.");'.PHP_EOL;
		}
		// sender_message // this makes problem when used with ckeditor
		if ($this->data['message']['show'] && $this->data['message']['req'])
		{
			$end .= '			frmvalidator.addValidation("sender_message","req","Please enter your message.");'.PHP_EOL;
		}
		if ($this->data['message']['show'] && $this->data['message']['valid'])
		{
			$end .= '			frmvalidator.addValidation("sender_message","minlen=10","Please enter your message - that\'s to short.");'.PHP_EOL;
			$end .= '			frmvalidator.addValidation("sender_message","maxlen=1000","Please enter your message - maximum of 1000 characters, no books please. . .");'.PHP_EOL;
		}
		// url - must be empty - another anti spam check - this applies automatically
		$end .= '			frmvalidator.addValidation("url","maxlen=0","This field must be empty. You must be a bot.");'.PHP_EOL;
		// check
		if ($disableadditionchecking==false)
		{
			$end .= '			frmvalidator.addValidation("check","req","Please check the antispam field and try again.");'.PHP_EOL;
			$end .= '			frmvalidator.addValidation("check","numeric","Please check the antispam field and try again.");'.PHP_EOL;
			$end .= '			frmvalidator.addValidation("check","lessthan=<?php echo ($n1+$n2+1); ?>","Please check the antispam field and try again.");'.PHP_EOL;
			$end .= '			frmvalidator.addValidation("check","greaterthan=<?php echo ($n1+$n2-1); ?>","Please check the antispam field and try again.");'.PHP_EOL;
		}
		$end .= '	</script>'.PHP_EOL;
		$end .= '</div>'.PHP_EOL;
		gpFiles::SaveTitle($this->title,$begin.$t.$end);//saves page's content
		echo 'Contact form was saved. Please test it, if it works. It should deliver emails to address '.$config['toemail'].'.';
	}
	
	function save_template($newcontent)
	{
		global $gptitles,$addonPathCode;
		$begin = $this->getfile($this->template,0);
		file_put_contents($this->template, $begin.' ?'.'> '.$newcontent);//saves page's content
		echo 'Template was saved. Now you can create contact form page with it.';
	}
	
	function save_settings()
	{
		global $gptitles,$config;
		if (!isset($gptitles[$this->title]))//if page is not registered yet, add it
		{
			$gptitles[$this->title]['type'] = 'page';
		}
		$gptitles[$this->title]['label'] = $_POST['pagelabel'];

		admin_tools::SavePagesPHP();//saves page's description
		if ( (!isset($config['toemail'])||!isset($config['toname'])) || (($config['toemail']!=$_POST['Receiver'])||($config['toname']!=$_POST['ReceiverName'])) )
		{
			$config['toemail'] = $_POST['Receiver'];
			$config['toname'] = $_POST['ReceiverName'];
			admin_tools::SaveConfig();
		}
		$this->data['IsHTML']= isset($_POST['IsHTML']) ? true:false;
		$this->data['EnableCKE']= isset($_POST['EnableCKE']) ? true:false;
		$this->data['name']['show']  = isset($_POST['name_show'])  ? true:false;
		$this->data['name']['valid'] = isset($_POST['name_valid']) ? true:false;
		$this->data['name']['req']   = isset($_POST['name_req'])   ? true:false;
		$this->data['phone']['show']  = isset($_POST['phone_show'])  ? true:false;
		$this->data['phone']['valid'] = isset($_POST['phone_valid']) ? true:false;
		$this->data['phone']['req']   = isset($_POST['phone_req'])   ? true:false;
		$this->data['email']['show']  = isset($_POST['email_show'])  ? true:false;
		$this->data['email']['valid'] = isset($_POST['email_valid']) ? true:false;
		$this->data['email']['req']   = isset($_POST['email_req'])   ? true:false;
		$this->data['subject']['show']  = isset($_POST['subject_show'])  ? true:false;
		$this->data['subject']['valid'] = isset($_POST['subject_valid']) ? true:false;
		$this->data['subject']['req']   = isset($_POST['subject_req'])   ? true:false;
		$this->data['message']['show']  = isset($_POST['message_show'])  ? true:false;
		$this->data['message']['valid'] = isset($_POST['message_valid']) ? true:false;
		$this->data['message']['req']   = isset($_POST['message_req'])   ? true:false;
		$this->data['message']['ta_params']   = $_POST['message_params'];
		$this->data['Addition']['show']   = isset($_POST['addition_show'])  ? true:false;
		$this->data['Captcha']['show']   = isset($_POST['captcha_show'])  ? true:false;
		$this->data['Captcha']['rctheme']   = $_POST['captcha_rctheme'];
		$this->data['msg_noscript']= $_POST['msg_noscript'];
		$this->data['msg_listing']= $_POST['msg_listing'];
		$this->data['msg_success']= $_POST['msg_success'];
		$this->data['msg_fail']= $_POST['msg_fail'];
		$this->data['msg_presubject']= $_POST['msg_presubject'];
		$this->data['msg_rcerror']= $_POST['msg_rcerror'];
		$this->data['ckValues']= $_POST['ckValues'];
		$this->data['WordWrap']= 0+$_POST['WordWrap'];
		$this->data['CharSet']= $_POST['CharSet'];
		$this->data['Language']= $_POST['Language'];
		$this->data['SMTPAuth']= isset($_POST['SMTPAuth']) ? true:false; 
		$this->data['Host']= $_POST['Host'];
		$this->data['Port']= 0+$_POST['Port'];
		$this->data['Username']= $_POST['Username'];
		$this->data['Password']= $_POST['Password'];
		$_POST['SMTPSecure']=strtolower($_POST['SMTPSecure']);
		if ($_POST['SMTPSecure']=='' || $_POST['SMTPSecure']=='ssl' || $_POST['SMTPSecure']=='tls')
		{
			$this->data['SMTPSecure']= $_POST['SMTPSecure'];
		}
		else
		{
			$this->data['SMTPSecure']= '';
		}
		$this->save_config();
		echo 'Settings are saved.';
	}
	
	function save_config()
	{
		global $addonPathCode;
		$str='<'.'?php defined(\'is_running\') or die(\'Not an entry point...\');
 ?'.'>';
		$str.=serialize($this->data);
		file_put_contents($addonPathCode.'/cfg.php', $str);
	}
	
	function publish()
	{
		global $gpmenu;
		if (!file_exists($this->formname))
		{
			echo 'Form file not exists.';
			return;
		}
		if (!isset($gpmenu[$this->title]))
		{
			$gpmenu[$this->title]=$this->data['level'];
			echo 'Contact page is now shown.<br/>';
		}
		else
		{
			$this->data["level"] = $gpmenu[$this->title];
			$this->save_config();
			unset($gpmenu[$this->title]);
			echo 'Contact page is now hidden.<br/>';
		}
		admin_tools::SavePagesPHP();
	}
	
	function create_template()
	{
		echo 'Creating template:<br/><br/> ';
		$t= '<div id="scf_container">'.PHP_EOL;
		$t.= ' <span class="scf_header">Contact Form</span>'.PHP_EOL;
		$t.= ' <form action="" method="post" name="scf_contact">'.PHP_EOL;
		$t.= ' <fieldset style="margin: 0pt; padding: 0pt; width: 100%;">'.PHP_EOL;
		if ($this->data['name']['show'])
		{
			$t.= '  <label class="scf_input_label" for="sender_name">Your Name</label> *'.($this->data['name']['req']?'(required)':'(recommended)').PHP_EOL;
			$t.= '  <input class="scf_input" id="sender_name" name="sender_name" style="display: block;" type="text" value="" />'.PHP_EOL;
		}
		if ($this->data['phone']['show'])
		{
			$t.= '  <label class="scf_input_label" for="sender_phone">Telephone</label> *'.($this->data['phone']['req']?'(required)':'(recommended)').PHP_EOL;
			$t.= '  <input class="scf_input" id="sender_phone" name="sender_phone" style="display: block;" type="text" value="" />'.PHP_EOL;
		}
		if ($this->data['email']['show'])
		{
			$t.= '  <label class="scf_input_label" for="sender_email">Your E-Mail</label> *'.($this->data['email']['req']?'(required)':'(recommended)').PHP_EOL;
			$t.= '  <input class="scf_input" id="sender_email" name="sender_email" style="display: block;" type="text" value="" />'.PHP_EOL;
		}
		if ($this->data['subject']['show'])
		{
			$t.= '  <label class="scf_input_label" for="sender_subject">Subject</label> *'.($this->data['subject']['req']?'(required)':'(recommended)').PHP_EOL;
			$t.= '  <input class="scf_input" id="sender_subject" name="sender_subject" style="display: block;" type="text" value="" />'.PHP_EOL;
		}
		if ($this->data['message']['show'])
		{
			$t.= '  <label class="scf_input_label" for="sender_message">Message</label> *'.($this->data['message']['req']?'(required)':'(recommended)').PHP_EOL;
			$t.= '  <textarea id="sender_message" name="sender_message" '.$this->data['message']['ta_params'].'></textarea>'.PHP_EOL;
		}
		if ($this->data['Addition']['show'])
		{
			$t.= '  <p>'.PHP_EOL;
			$t.= '    <label class="scf_input_label" for="check">Antispam/antibot protection</label> *(required)<br/>'.PHP_EOL;
			$t.= '    Enter the # sum of&nbsp; [NUMBERS] :  '.PHP_EOL;
			$t.= '    <input class="scf_input" id="check" name="check" style="display: inline;" type="text" value="" />'.PHP_EOL;
			$t.= '  </p>'.PHP_EOL;
		}
		if ($this->data['Captcha']['show'])
		{
			$t.= '<br/>  [CAPTCHA] <br/>'.PHP_EOL;
		}
		$t.= '  <input id="url" name="url" style="display: none;" type="text" value="" />'.PHP_EOL;
		$t.= '  <input id="website" name="website" style="display: none;" type="text" value="" />'.PHP_EOL;
		$t.= '  <input class="scf_submit" name="submitForm" type="submit" value="Send" />'.PHP_EOL;
		$t.= '  &nbsp;<input class="scf_reset" type="reset" value="Reset" />'.PHP_EOL;
		$t.= '  &nbsp;<span class="error_strings" id="scf_contact_errorloc"> </span>'.PHP_EOL;
		$t.= ' </fieldset>'.PHP_EOL;
		$t.= ' </form>'.PHP_EOL;
		$t.= '</div>'.PHP_EOL;
		$str='<'.'?php defined(\'is_running\') or die(\'Not an entry point...\');
 ?'.'>';
		file_put_contents($this->template, $str.PHP_EOL.$t); // save template
		$t = str_replace('type="submit"','type="submit" disabled="disabled"',$t);
		echo $t.'<br/>Template was created. You can edit it now, or simply create new contact form.<br/><br/>';
	}
	
	function view_template()
	{
		echo 'This is preview of current contact form template. It can be used to assemble working smtp contact form. / <a href="javascript:history.go(-1)"> go back </a><br/><br/> ';
		$t = $this->getfile($this->template,1);
		$t = str_replace('type="submit"','type="submit" disabled="disabled"',$t);
		echo $t.'<br/>';
	}
	
	function Start()
	{
		global $addonPathCode;
		if (isset($_POST['save_settings']))
		{
			$this->save_settings();
			$this->formlabel = $_POST['pagelabel'];
		}
		if (isset($_POST['save_data']))
		{
			$this->save_template($_POST['textfield']);
		}
		parse_str($_SERVER['QUERY_STRING']);
		if (isset($cmd) && ($cmd=='edit_template'))
		{
			if (file_exists($this->template))
			{
				$this->edit_template();
			}
			else
			{
				echo 'Template not exists.';
				$this->menu();
			}
		}
		elseif (isset($cmd) && ($cmd=='view_template'))
		{
			if (file_exists($this->template))
			{
				$this->view_template();
				$this->menu();
			}
			else
			{
				echo 'Template not exists.';
				$this->menu();
			}
		}
		elseif (isset($cmd) && ($cmd=='set_defaults'))
		{
			$this->data['ckValues'] = ckDefault;
			$this->save_config();
			echo 'CKEditor settings are now set as by default.<br/><br/>';
			$this->menu();
		}
		elseif (isset($cmd) && ($cmd=='del_config'))
		{
			if (file_exists($addonPathCode.'/cfg.php'))
			{
				unlink($addonPathCode.'/cfg.php');
				echo 'The file '.$addonPathCode.'/cfg.php was deleted.';
				$this->__construct();/*load defaults*/
			}
			else
			{
				echo 'Config file not exists.';
			}
			$this->menu();
		}
		elseif (isset($cmd) && ($cmd=='create_template'))
		{
			$this->create_template();
			$this->menu();
		}
		elseif (isset($cmd) && ($cmd=='create_form'))
		{
			$this->create_form();
			$this->menu();
		}
		elseif (isset($cmd) && ($cmd=='publish'))
		{
			$this->publish();
			$this->menu();
		}
		else
		{
			$this->menu();
		}
	}
}


	
$o = new Edit; //create object
$o->Start(); //execute it
unset($o); //release memory



//global $config, $gpmenu, $gptitles;
//echo '<pre>config ';print_r($config); echo '</pre><br/>';//admin_tools::SaveConfig();
//echo '<pre>gpmenu ';print_r($gpmenu); echo '</pre><br/>'; //
//echo '<pre>gptitles ';print_r($gptitles); echo '</pre><br/>'; //admin_tools::SavePagesPHP();
