<?php
defined('is_running') or die('Not an entry point...');

require('SimpleBlogCommon.php');
require('recaptcha.php');
//includeFile('tool/recaptcha.php');

class SimpleBlog extends SimpleBlogCommon{
	
	
	function SimpleBlog(){
		global $page, $langmessage,$addonFolderName;
		$this->Init();
		
		/*
		 * If the text values have changed, it would be good to regenerate the gadget...
		 */
		
		
		$cmd = common::GetCommand();
		$show = true;
		if( common::LoggedIn() ){
			
			switch($cmd){
				
				//regen
				case 'regen':
					$this->GenStaticContent();
					$this->Config();
					$show = false;
					message($langmessage['SAVED']);
				break;
				
				//config
				case 'save_config':
					if( $this->SaveConfig() ){
						$this->GenStaticContent();
					}
				case 'config':
					$this->Config();
					$show = false;
				break;
				
				
				//delete
				case 'delete':
					if( $this->Delete() ){
						$this->GenStaticContent();
					}
				break;
				
				//editing
				case 'save_edit':
					if( $this->SaveEdit() ){
						$this->GenStaticContent();
						break;
					}
				case 'edit':
					$this->EditPost();
					$show = false;
				break;
				
				//creating
				case 'save_new';
					if( $this->SaveNew() ){
						$this->GenStaticContent();
						break;
					}
				case 'new_form':
					$this->NewForm();
					$show = false;
				break;
				
			}
			
			
			$page->admin_links[] = array('Special_Blog','Blog Home');
			
			$page->admin_links[] = array('Special_Blog','New Blog Post','cmd=new_form');
			
			$page->admin_links[] = array('Special_Blog','Configuration','cmd=config');
			
			$page->admin_links[] = array('Admin_Theme_Content',$langmessage['editable_text'],'cmd=addontext&addon='.urlencode($addonFolderName),' name="ajax_box" ');
			
			//$page->admin_links[] = array('Special_Blog','Regenerate Gadget','cmd=regen');
			
			
			//$label = 'Number of Posts: '. $this->blogData['post_index'];
			$label = 'Number of Posts: '. count($this->blogData['post_list']);
			$page->admin_links[$label] = '';
			
			echo '<div style="display:none">';

			echo '<div id="simple_blog_delete" class="inline_box">';
			echo '<form method="post" action="'.common::GetUrl('Special_Blog').'">';
				echo $langmessage['delete_confirm'];
				echo ' <input type="hidden" name="id" value="" />';
				echo  ' <input type="hidden" name="cmd" value="delete" />';
				echo  ' <input type="submit" name="aaa" value="'.$langmessage['delete'].'" />';
			echo '</form>';
			echo '</div>';

			echo '<div id="simple_blog_delete_comment" class="inline_box">';
			echo '<form method="post" action="'.common::GetUrl('Special_Blog').'">';
				echo $langmessage['delete_confirm'];
				echo ' <input type="hidden" name="id" value="" />';
				echo ' <input type="hidden" name="comment_id" value="" />';
				echo  ' <input type="hidden" name="cmd" value="delete_comment" />';
				echo  ' <input type="submit" name="aaa" value="'.$langmessage['delete'].'" />';
			echo '</form>';
			echo '</div>';
			
			echo '</div>';
		
		}
		
		if( $show ){
			switch($cmd){
				case 'opencomments':
				case 'closecomments':
				case 'delete_comment':
				case 'Add Comment':
				case 'save_edit':
				case 'post':
					$this->ShowPost($cmd);
				break;
				case 'page':
				default:
					$this->ShowPage();
				break;
			}
		}
	
	}
	
	function ShowPost($cmd){
		global $addonPathData,$langmessage,$page;
		
		
		$post_index = $_REQUEST['id'];
		$posts = $this->GetPostFile($post_index,$post_file);
		if( $posts === false ){
			message($langmessage['OOPS']);
			return;
		}

		
		if( !isset($posts[$post_index]) ){
			message($langmessage['OOPS']);
			return;
		}
		
		$commentSaved = false;
		switch($cmd){
			
			//close comments
			case 'closecomments':
				$this->CloseComments($post_index);
			break;
			case 'opencomments':
				$this->OpenComments($post_index);
			break;

			
			//commments
			case 'Add Comment':
				if( $this->AddComment($post_index) ){
					$commentSaved = true;
				}else{
					$this->CommentForm($post_index,true);
					return;
				}
			break;
			case 'delete_comment':
				$this->DeleteComment($post_index);
			break;
		}
		
		
		$post =& $posts[$post_index];
		$this->ShowPostContent($post,$post_index);
		
		$page->label = str_replace('_',' ',$post['title']);
		
		$this->PostLinks($post_index);
		
		//comments
		if( $this->blogData['allow_comments'] ){
			echo '<div class="comment_container">';
			$this->ShowComments($post_index);
			if( !$commentSaved ){
				$this->CommentForm($post_index);
			}
			echo '</div>';
		}
	}
	
	function ShowComments($post_index){
		global $addonPathData;
		
		$data = $this->GetCommentData($post_index);
		if( empty($data) ){
			return;
		}
		
		echo '<h3>';
		echo gpOutput::GetAddonText('Comments');
		echo '</h3>';
			
		$this->GetCommentHtml($data,$post_index,true);
		
	}
	
	
	function CloseComments($post_index){
		global $langmessage;
		
		$this->blogData['post_info'][$post_index]['closecomments'] = true;
		if( !$this->SaveIndex() ){
			message($langmessage['OOPS']);
		}else{
			message($langmessage['SAVED']);
		}
	}
	
	function OpenComments($post_index){
		global $langmessage;
		
		unset($this->blogData['post_info'][$post_index]['closecomments']);
		if( !$this->SaveIndex() ){
			message($langmessage['OOPS']);
		}else{
			message($langmessage['SAVED']);
		}
	}
	
	function CommentForm($post_index,$showCaptcha=false){
		
		if( isset($this->blogData['post_info'][$post_index]['closecomments']) ){
			echo '<div class="comments_closed">';
			echo gpOutput::GetAddonText('Comments have been closed.');
			echo '</div>';
			return;
		}

		
		$_POST += array('name'=>'','website'=>'http://','comment'=>'');
		
		echo '<h3>';
		echo gpOutput::GetAddonText('Leave Comment');
		echo '</h3>';

		
		echo '<form method="post" action="'.common::GetUrl('Special_Blog','cmd=post&id='.$post_index).'">';
		//echo '<input type="hidden" name="id" value="'.htmlspecialchars($post_index).'" />';
		echo '<table>';
		echo '<tr>';
			echo '<th>';
			echo gpOutput::GetAddonText('Name');
			echo '</th>';
			echo '<td>';
			echo '<input type="text" name="name" class="text" value="'.htmlspecialchars($_POST['name']).'" />';
			echo '</td>';
			echo '</tr>';
			
		if( !empty($this->blogData['commenter_website']) ){
			echo '<tr>';
				echo '<th>';
				echo gpOutput::GetAddonText('Website');
				echo '</th>';
				echo '<td>';
				echo '<input type="text" name="website" class="text" value="'.htmlspecialchars($_POST['website']).'" />';
				echo '</td>';
				echo '</tr>';
		}
			
		echo '<tr>';
			echo '<th>';
			echo gpOutput::ReturnText('Comment');
			echo '</th>';
			echo '<td>';
			echo '<textarea name="comment" cols="30" rows="7" >';
			echo htmlspecialchars($_POST['comment']);
			echo '</textarea>';
			echo '</td>';
			echo '</tr>';
			

		if( $showCaptcha && $this->blogData['comment_captcha'] && gp_recaptcha::isActive() ){

			
			echo '<tr>';
			echo '<th>';
			echo gpOutput::ReturnText('captcha');
			echo '</th>';
			echo '<td colspan="2">';
			gp_recaptcha::Form();
			echo '</td></tr>';
		}

		echo '<tr>';
			echo '<th>';
			echo '</th>';
			echo '<td colspan="2">';
			echo '<input type="hidden" name="cmd" value="Add Comment" />';
			$html = '<input type="submit" name="" class="submit" value="%s" />';
			echo gpOutput::GetAddonText('Add Comment',$html);
			echo '</td>';
			echo '</tr>';
		
		echo '</table>';
		echo '</form>';
		
				
		
		
		
		
	}
	
	function PostLinks($post_index){
		$position = array_search( (int)$post_index,$this->blogData['post_list'],true);
		echo '<p>';
		if( isset($this->blogData['post_list'][$position+1]) ){
			$html = common::Link('Special_Blog','%s','cmd=post&id='.$this->blogData['post_list'][$position+1],'class="blog_older"');
			echo gpOutput::GetAddonText('Older Entry',$html);
			echo '&nbsp;';
		}
		
		$html = common::Link('Special_Blog','%s');
		echo gpOutput::GetAddonText('Blog Home',$html);
		echo '&nbsp;';
		
		if( isset($this->blogData['post_list'][$position-1]) ){
			$html = common::Link('Special_Blog','%s','cmd=post&id='.$this->blogData['post_list'][$position-1],'class="blog_newer"');
			echo gpOutput::GetAddonText('Newer Entry',$html);
		}
		
		echo '</p>';		
	}
	
	
	function ShowPage(){
		global $addonPathData;
		
		
		$page = 0;
		if( isset($_GET['page']) && is_numeric($_GET['page']) ){
			$page = (int)$_GET['page'];
		}
		$start = $page * $this->blogData['per_page'];
		
		$show_posts = array_slice($this->blogData['post_list'], $start, $this->blogData['per_page'] );
		
		
		$posts = array();
		foreach($show_posts as $post_index){
			
			//get $posts
			if( !isset($posts[$post_index]) ){
				$posts = $this->GetPostFile($post_index,$post_file);
			}
			
			$post =& $posts[$post_index];
			
			$this->ShowPostContent($post,$post_index);
			
		}
		
		echo '<p>';
		if( $page > 0 ){
			$html = common::Link('Special_Blog','%s','page='.($page-1),'class="blog_newer"');
			echo gpOutput::GetAddonText('Newer Entries',$html);
		}
		echo '&nbsp;';
		$html = common::Link('Special_Blog','%s');
		echo gpOutput::GetAddonText('Blog Home',$html);
		echo '&nbsp;';

		$next_post = array_slice($this->blogData['post_list'], $start+$this->blogData['per_page'], 1 );
		if( count($next_post) > 0 ){
			$html = common::Link('Special_Blog','%s','page='.($page+1),'class="blog_older"');
			echo gpOutput::GetAddonText('Older Entries',$html);
		}
		echo '</p>';
		
	}
	
	function ShowPostContent(&$post,&$post_index){
		global $langmessage;
		
		echo '<h2 id="blog_post_'.$post_index.'">';
		$label = str_replace('_',' ',$post['title']);
		echo common::Link('Special_Blog',$label,'cmd=post&id='.$post_index);
		echo '</h2>';
		echo '<div class="simple_blog_info">';
		echo '<span>';
		echo date($this->blogData['date_format'],$post['time']);
		echo '</span>';
		
		if( $this->blogData['allow_comments'] && isset($this->blogData['post_info'][$post_index]['comments']) ){
			$comments = $this->blogData['post_info'][$post_index]['comments'];
			echo '<span class="space"> | </span>';
			
			echo '<span>';
				echo gpOutput::GetAddonText('Comments');
				echo ': '.$comments;
			echo '</span>';
		}
		
		
		if( common::LoggedIn() ){
			echo '<span class="space"> | </span>';
			
			echo '<span>';
			echo common::Link('Special_Blog',$langmessage['edit'],'cmd=edit&id='.$post_index);
			echo '</span>';
			
			echo '<span class="space"> | </span>';
			
			echo '<span>';
			$input = '<input type="hidden" name="id" value="'.$post_index.'" />';
			echo common::Link('Special_Blog',$langmessage['delete'].$input,'cmd=popup',' name="inline_box" rel="#simple_blog_delete"');
			echo '</span>';
			
			
			if( $this->blogData['allow_comments'] ){
				echo '<span class="space"> | </span>';
				
				echo '<span>';
				if( isset($this->blogData['post_info'][$post_index]['closecomments']) ){
					$html = common::Link('Special_Blog','%s','cmd=opencomments&id='.$post_index,'name="creq"');
					echo gpOutput::GetAddonText('Open Comments',$html);
				}else{
					$html = common::Link('Special_Blog','%s','cmd=closecomments&id='.$post_index,'name="creq"');
					echo gpOutput::GetAddonText('Close Comments',$html);
				}
				echo '</span>';
			}
		}
		
		echo '</div>';
		
		echo $post['content'];
		
		echo '<br/>';
		
		//echo showArray($post);
		echo '<div class="clear"></div>';
		
	}
	
	
	/* comments */
	
	function GetCommentData($post_index){
		global $addonPathData,$langmessage;
		
		$data = array();
		$commentDataFile = $addonPathData.'/comments_data_'.$post_index.'.txt';
		if( file_exists($commentDataFile) ){
			$dataTxt = file_get_contents($commentDataFile);
			if(  !empty($dataTxt) ){
				$data = unserialize($dataTxt);
			}
		}
		return $data;
	}
	
	function DeleteComment($post_index){
		global $addonPathData,$langmessage;
		
		$data = $this->GetCommentData($post_index);
		
		$comment = $_POST['comment_id'];
		if( !isset($data[$comment]) ){
			message($langmessage['OOPS']);
			return;
		}
		
		unset($data[$comment]);
		
		if( $this->SaveCommentData($post_index,$data) ){
			message($langmessage['SAVED']);
			return true;
		}else{
			message($langmessage['OOPS']);
			return false;
		}			
		
	}
	
	function AddComment($post_index){
		global $addonPathData,$langmessage;
		
		if( isset($this->blogData['post_info'][$post_index]['closecomments']) ){
			return;
		}
		
		$data = $this->GetCommentData($post_index);
		
		//need a captcha?
		
		if( $this->blogData['comment_captcha'] && gp_recaptcha::isActive() ){
			
			if( !isset($_POST['recaptcha_challenge_field']) ){
				return false;
				
			}elseif( !gp_recaptcha::Check() ){
				return false;
				
			}
		}
		
		
		if( empty($_POST['name']) ){
			$field = gpOutput::SelectText('Name');
			message($langmessage['OOPS_REQUIRED'],$field);
			return false;
		}
		
		if( empty($_POST['comment']) ){
			$field = gpOutput::SelectText('Comment');
			message($langmessage['OOPS_REQUIRED'],$field);
			return false;
		}
		
		
		$temp = array();
		$temp['name'] = htmlspecialchars($_POST['name']);
		$temp['comment'] = nl2br(strip_tags($_POST['comment']));
		$temp['time'] = time();
		
		if( !empty($_POST['website']) && ($_POST['website'] !== 'http://') ){
			$website = $_POST['website'];
			if( strpos($website,'://') === false ){
				$website = false;
			}
			if( $website ){
				$temp['website'] = $website;
			}
		}
		
		
		
		$data[] = $temp;
		
		if( $this->SaveCommentData($post_index,$data) ){
			message($langmessage['SAVED']);
			return true;
		}else{
			message($langmessage['OOPS']);
			return false;
		}
	}
	
	
	function SaveCommentData($post_index,$data){
		global $addonPathData;
		
		$dataTxt = serialize($data);
		$commentDataFile = $addonPathData.'/comments_data_'.$post_index.'.txt';
		if( !gpFiles::Save($commentDataFile,$dataTxt) ){
			message($langmessage['OOPS']);
			return false;
		}
		
		$this->blogData['post_info'][$post_index]['comments'] = count($data);
		$this->SaveIndex();
		
		return true;
	}
	
	
	function GetCommentHtml($data,$post_index,$admin = false){
		global $langmessage;
		
		if( is_array($data) ){
			foreach($data as $key => $comment){
				echo '<div class="comment_area">';
				echo '<p class="name">';
				if( ($this->blogData['commenter_website'] == 'nofollow') && !empty($comment['website']) ){
					echo '<b><a href="'.$comment['website'].'" rel="nofollow">'.$comment['name'].'</a></b>';
				}elseif( ($this->blogData['commenter_website'] == 'link') && !empty($comment['website']) ){
					echo '<b><a href="'.$comment['website'].'">'.$comment['name'].'</a></b>';
				}else{
					echo '<b>'.$comment['name'].'</b>';
				}
				echo ' &nbsp; ';
				echo '<span>';
				echo date($this->blogData['date_format'],$comment['time']);
				echo '</span>';
				
				
				if( common::LoggedIn() ){
					
					echo ' &nbsp; ';
					$input = '<input type="hidden" name="id" value="'.$post_index.'" />';
					$input .= '<input type="hidden" name="comment_id" value="'.$key.'" />';
					echo common::Link('Special_Blog',$langmessage['delete'].$input,'cmd=popup',' name="inline_box" rel="#simple_blog_delete_comment"');
				}
				
				
				echo '</p>';
				echo '<p class="comment">';
				echo $comment['comment'];
				echo '</p>';
				echo '</div>';
			}
		}
	}
}
	

